{

Pings on a Stingray (SRLM version)

Tests out the Stingray robot

}

CON

  _xinfreq = 5_000_000
  _clkmode = xtal1 + pll16x

  prpin = 6
  pcpin = 7
  plpin = 8


  lmforward = 25 
  lmbackward = 24
  rmforward = 26
  rmbackward = 27

  mindist = 300 '10 cm

  period = 5000 'for PWM object

  basespeed = 17

OBJ

  ping : "Ping"
  com  : "FullDuplexSerialPlus"
  pwm  :  "PWM_32_v2"
  adc  : "MCP3208_fast"
  
VAR

  long pingstack [100]
  long distances [3]
  long temp[3]
  long linemin[6]
  long linemax[6]
  long line[6]
  long image 'All 6 bits are in here
  long binout[6] 'line output in binary

PUB Main | i, t1, t2, t3, lines

  com.start(31, 30, 0, 57600)
  waitcnt(clkfreq*2 + cnt)

  dira[3] := 0 
  
  t3 := 0
  t1 := t2 := ina[3]
  repeat
    t1 := ina[3]
    com.dec(t1)
    if t1 <> t2
      com.str(string("new value!"))
      com.dec(++t3)
      com.tx(13)
    t2 := t1

  'com.start(9,10,0,9600)
  'com.start(31, 30, 0, 57600)
  pwm.start
  adc.start(1,0,2,0)
  dira[3] := 0

  cognew(runpings, @pingstack)
  waitcnt(clkfreq*2 + cnt)

  'timer := cnt + (clkfreq*15)


  
  'Get the values for the line
  repeat until ina[3] == 1
    repeat i from 0 to 5
      line[i] := adc.in(i)
      if(linemin[i] > line[i] or linemin[i] == 0)
        linemin[i] := line[i]
      if(linemax[i] < line[i])
        linemax[i] := line[i]

  repeat i from 0 to 5
    t1 := (linemin[i] + linemax[i])/2
    t2 := 0'||(linemin[i] - linemax[i])/64
    linemin[i] := t1-t2
    linemax[i] := t1+t2

  waitcnt(clkfreq*2 + cnt)

  
  repeat
    image := 0
    repeat i from 0 to 5
      line[i] := adc.in(i)
      'com.dec(line[i])
      'com.tx(9)
      if(line[i] > linemax[i])
        binout[i] := 1
      if(line[i] < linemin[i])
        binout[i] := 0
      image := image + binout[i]
      if(i <> 5)
        image <<= 1  

    repeat i from 0 to 5
      'com.dec(binout[i])
    'com.tx(13)
    if(image == 0) 'Go forward
      calculatemotor(0, basespeed*2)
    repeat i from 5 to 0
      if(binout[i])
        if(i > 3)'go left
          calculatemotor(-basespeed*(i-3), basespeed*(4-i))
        elseif(i < 2) 'go right
          calculatemotor(basespeed*i, basespeed*(i-1))
        'straight is up above
        quit
           
      
    
    {if(binout[1] == 1) 'turn slightly right
      calculatemotor(20,20)
    elseif(binout[4] == 1) ' turn slightly left
      calculatemotor(-20,20)
    elseif(binout[0] == 1) 'Turn harder right
      calculatemotor(35, 0)
    elseif(binout[5] == 1)
      calculatemotor(-35,0) 'turn harder left
    else 'if(binout[2] == 1 or binout[3] == 1) 'go straight
      calculatemotor(0,20)
    }
        
  
 { repeat
    repeat i from 0 to 2
      temp[i] := distances[i]

    if((temp[0] <# temp[1] <# temp[2]) < mindist) 'stuck in corner
      if(temp[0] > temp[2])'back up to right
        calculatemotor(20,-20)
      else
        calculatemotor(-20,-20)
      waitcnt(clkfreq/4 + cnt)        
    elseif(temp[1] > (mindist*2)) 'most room straight
      calculatemotor(0,60)
    elseif(temp[0] > temp[1] and temp[0] > temp[2]) 'more room to left
      if(temp[0] > mindist) 
        calculatemotor(-30,30)
      else
        calculatemotor(30,-30)
    elseif(temp[2] > temp[1] and temp[2] > temp[0]) 'more room to right
      if(temp[2] > mindist)
        calculatemotor(30,30)
      else
        calculatemotor(-30,30)
    else 'No room forward, go backwards
      calculatemotor(-30,-30)
    
    
       }
    
  
  {
  'wander around without hitting much
  repeat
    if(distances[0] > mindist and distances[1] > mindist and distances[2] > mindist)
      calculatemotor(0, 20)
    else
      calculatemotor(-20,-20)
      waitcnt(clkfreq + cnt)
  }
    
  
  {'Test pings
  repeat
    com.tx(13)
    repeat i from 0 to 2
      com.dec(distances[i])
      com.tx(13)
   }   
    




PUB runpings
  repeat
    distances[0] := ping.millimeters(prpin)
    waitcnt(clkfreq/100 + cnt)
    distances[1] := ping.millimeters(pcpin)
    waitcnt(clkfreq/100 + cnt)
    distances[2] := ping.millimeters(plpin)
    waitcnt(clkfreq/100 + cnt)

PUB calculatemotor(turnrate, speed)
  

{
A turn rate of 0 is straight, -100 is full left, 100 is full right

speed is how fast to "turn" minimu, used for going straight, + is forward, - is backwards
-Units same as above

}
  speed := -100 #> speed <# 100
  turnrate := -100 #> turnrate <# 100
  if turnrate == 0
    if(speed => 0) 'Go straight forward
      pwm.duty(rmbackward, 0,0)
      pwm.duty(lmbackward, 0,0)
      pwm.duty(lmforward, speed, period)
      pwm.duty(rmforward, speed, period)
    else 'Go straight backwards
      ||speed
      pwm.duty(rmforward, 0,0)
      pwm.duty(lmforward, 0,0)
      pwm.duty(lmbackward, ||speed, period)
      pwm.duty(rmbackward, ||speed, period)

  elseif(turnrate > 0) 'turn right
    if(speed => 0) 'Go on a curve forward right
      pwm.duty(rmbackward, 0,0)
      pwm.duty(lmbackward, 0,0)
      pwm.duty(lmforward, (speed+turnrate)<#100, period)
      pwm.duty(rmforward, speed, period)
    else 'Go on a curve backwards right
      pwm.duty(rmforward, 0,0)
      pwm.duty(lmforward, 0,0)
      pwm.duty(lmbackward, (||speed+turnrate)<#100, period)
      pwm.duty(rmbackward, ||speed, period)

  
  elseif(turnrate < 0) 'turn left
    ||turnrate
    if(speed => 0) 'Go on a curve forward left
      pwm.duty(rmbackward, 0,0)
      pwm.duty(lmbackward, 0,0)
      pwm.duty(rmforward, (speed+turnrate)<#100, period)
      pwm.duty(lmforward, speed, period)
    else 'Go on a curve backwards left
      pwm.duty(rmforward, 0,0)
      pwm.duty(lmforward, 0,0)
      pwm.duty(rmbackward, (||speed+turnrate)<#100, period)
      pwm.duty(lmbackward, ||speed, period)
   
    
    
     



                                   
  